/* 
 * cryptint_user.h: header for userland plugin
 * Copyright (C) 2002 Axel Burri <axel@purrly.ch>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

#ifndef CRYPTINT_USER_H
#define CRYPTINT_USER_H



/* Types for callback functions.  */

typedef int (*cryptint_sign_cb) (char *buf, size_t length, char *sig_buf, size_t sig_buf_length, size_t *sig_length);
typedef int (*cryptint_verify_cb) (char *plain, char *sig, size_t size_plain, size_t size_sig);



int cryptint_init(char *filename, cryptint_sign_cb sign, cryptint_verify_cb verify);
void cryptint_listen();




#endif /* CRYPTINT_USER_H */
